/******************************************************************************
 * @file     main.c
 * @brief    Main program body
 * @version  V4.0.3
 * @date     30-July-2026
 *
 * @note
 * Copyright (C) 2022 Spintrol Electronic Technology (Shanghai) Co., Ltd.. All rights reserved.
 *
 * @attention
 * THIS SOFTWARE JUST PROVIDES CUSTOMERS WITH CODING INFORMATION REGARDING
 * THEIR PRODUCTS, WHICH AIMS AT SAVING TIME FOR THEM. SPINTROL SHALL NOT BE
 * LIABLE FOR THE USE OF THE SOFTWARE. SPINTROL DOES NOT GUARANTEE THE
 * CORRECTNESS OF THIS SOFTWARE AND RESERVES THE RIGHT TO MODIFY THE SOFTWARE
 * WITHOUT NOTIFICATION.
 *
 ******************************************************************************/

#include<stdio.h>

#if defined(SPC1158)
#include "spc1158.h"
#elif defined(SPD1148)
#include "spd1148.h"
#elif defined(SPD1178)
#include "spd1178.h"
#elif defined(SPD1188)
#include "spd1188.h"
#elif defined(SPD1163)
#include "spd1163.h"
#else
#include "spc1168.h"
#endif

#define TimerPeriodCount         1000        /* 1000MS */

#define ExternInputGpio          GPIO_0      /* External input signal enable gpio */
#define ExternInputActiveLevel   0           /* External input polarity */


/*************************************************************************************************************************
*
* @brief This case shows how to use a external signal as GTimer enable signal.
*
*************************************************************************************************************************/


int main()
{
    FLASH_WALLOW();

#if defined(SPC1158)
    FLASH_SetTiming(100000000);
    /* Disable flash write access after flash operation had done */
    FLASH_WDIS();

    CLOCK_InitWithRCO(100000000UL);
#else
    FLASH_SetTiming(200000000);
    /* Disable flash write access after flash operation had done */
    FLASH_WDIS();

    CLOCK_InitWithRCO(200000000UL);
#endif

    Delay_Init();

    /*
     * Init the UART
     *
     * 1.Set the GPIO34/35 as UART FUNC
     *
     * 2.Enable the UART CLK
     *
     * 3.Set the rest para
     */
    GPIO_SetPinChannel(GPIO_34, GPIO34_UART_TXD);
    GPIO_SetPinChannel(GPIO_35, GPIO35_UART_RXD);
    CLOCK_EnableModule(UART_MODULE);
    UART_Init(UART, 38400);

    /* Set ExternInputGpio as GPIO FUNC */
    GPIO_SetPinAsGPIO(ExternInputGpio);

    /* Set ExternInputGpio direction */
    GPIO_SetPinDir(ExternInputGpio, GPIO_INPUT);

    /* Open Global INT for TIMER1 */
    NVIC_EnableIRQ(TIMER1_IRQn);
    
    /* Init TIMWE1 */
    TIMER_Init(TIMER1, TimerPeriodCount);

    /* Set external input signal mode */
    TIMER1->TMRCTL.bit.EXTINMODE = TMRCTL_BIT_EXTINMODE_EXTEN;

    /* Select external input signal */
    TIMER1->TMRCTL.bit.EXTSEL = ExternInputGpio;
    
    /* Set external input signal active level */
    if (ExternInputActiveLevel)
    {
        TIMER1->TMRCTL.bit.EXTPOL = TMRCTL_BIT_EXTPOL_ACTIVE_HIGH;
    }
    else
    {
        TIMER1->TMRCTL.bit.EXTPOL = TMRCTL_BIT_EXTPOL_ACTIVE_LOW;
    }

    while (1)
    {

    }
}

void TIMER1_IRQHandler()
{
    /* Clear the INT */
    TIMER_ClearInt(TIMER1);

    /* Disable the TIMER1 */
    TIMER_Stop(TIMER1);

    printf("G timer extern gpio enable test OK\n");
}
